#!/usr/bin/perl
if ($#ARGV == 0) {
$baudrate=$ARGV[0];
}
else {
$baudrate=0;
}
$baudtext='0';
if ( $baudrate != 0 ) {
$baudtext=substr($baudrate,0,-2);
}
#print "$baudtext\n";
##################################################
#Determine if we are running LILO or GRUB as default boot loader
#(grubby doesn't tell us that under 7.3)
#Boot sector will contain GRUB if it is grub,
#won't if it isn't.
##################################################
$grubbootdrive="";
$lilobootdrive="";
if ( -r "/boot/grub/grub.conf" )
{
	$grubbootline=`grep 'boot=' /boot/grub/grub.conf`;
	chop $grubbootline;
#	print "grubbootline\n";
#	print "$grubbootline\n";
        ($grubtext,$grubbootdrive)=split("=",$grubbootline);
#        print "grubbootdrive\n";
#        print "$grubbootdrive\n";
}
if ( -r "/etc/lilo.conf" ) 
{ 
	$lilobootline=`grep 'boot=' /etc/lilo.conf`;
	chop $lilobootline;
#	print "lilobootline\n";
#	print "$lilobootline\n";
	($lilotext,$lilobootdrive)=split('=',$lilobootline);
#        print "lilobootdrive\n";
#	print "$lilobootdrive\n";
}
$bootsect="";
if ($grubbootdrive ne "")
{
        $grubbootsect=`dd if=$grubbootdrive count=1 bs=512 2>/dev/null | grep GRUB`;
#	print "grubbootsect\n";
#	print "$grubbootsect\n";
	if ( $grubbootsect ne "")
        {
            $bloader="GRUB";
#	    print "bloader $bloader\n";
        }
}
if (($grubbootsect eq "") && ($lilobootdrive ne ""))
{
	$lilobootsect=`dd if=$lilobootdrive count=1 bs=512 2>/dev/null | grep LILO`;
#	print "lilobootsect\n";
#	print "$lilobootsect\n";
        if ($lilobootsect ne "")
	{
		$bloader="LILO";
#	    	print "bloader $bloader\n";
        }
}

if ($bloader eq "GRUB")
{
#
# Check for previous versions of memtest line in grub.conf
#
#print "bloader $bloader\n";
$prevgrub=`grep 'kernel /boot/memtest' /boot/grub/grub.conf | awk '{print $2}'`;
#print "prevgrub: \n";
#print "$prevgrub";
# Remove previous versions of the memtest line
if ( $prevgrub ne "")
{
@prevgrublines=split("\n",$prevgrub);
foreach $prevline (@prevgrublines)
{
$prevline=~ s/ //g;
$prevline=~ s/kernel//g;
$prevline=~ s/\t//g;
$lenprev=length($prevline);
#print "lenprev: $lenprev\n";
#print "prevline: $prevline\n";
system "grubby --remove-kernel=$prevline";
}
}
system "grubby --add-kernel=/boot/memtest_$baudtext.bin --title=memtest86";
}
####################################################
# Modify /etc/lilo.conf
####################################################
if ($bloader eq "LILO")
{
$newimageline="image=/boot/memtest_$baudtext.bin\n";
$newlabelline="label=memtest86\n";
open (LILO,"/etc/lilo.conf");
while ($ThisLine = <LILO>) {
   # If there is already a 'label=memtest86' line, don't change it...
   if ($ThisLine =~ m/label=memtest86/ ) {
      print "label=memtest86 line already in lilo.conf...\n";
      $Memtestlinepresent = 1;
   }
   # If there is already an image line, check if it is OK
   if ($ThisLine =~ m/image.*memtest/ ) {
#        print "ThisLine: \n";
#        print "$ThisLine:";
#        print "newimageline: \n";
#        print "$newimageline";
     if ($ThisLine eq $newimageline ) { 
          print "correct image line already in lilo.conf ..\n";
          }
          else {
          print "replacing image line with correct line \n";
          $ThisLine=$newimageline;
          }
      $imagelinepresent = 1;
    }
   # Store lilo line...
   push @lilo, $ThisLine;

}
close (LILO);
# Now check if we need to add any lines
   if ( $imagelinepresent != 1 ) { 
      push @lilo, $newimageline;
   }
   if ( $Memtestlinepresent != 1 ) { 
      push @lilo, $newlabelline;
   }

# open /etc/lilo.conf for writing
open (LILO,">/etc/lilo.conf");

# Write file...
foreach $ThisLine (@lilo) {
   print LILO $ThisLine;

}
close (LILO);

print "\nWrote /etc/lilo.conf and now running lilo...\n";
system("/sbin/lilo");


}
